//+------------------------------------------------------------------+
//|                                                CTsLoggerTest.mq5 |
//|                                         Copyright 2025, Trefoter |
//|                             https://www.mql5.com/ru/users/useral |
//+------------------------------------------------------------------+

#property copyright "Copyright 2025, Trefoter"
#property link      "https://www.mql5.com/ru/users/useral"
#property version   "1.00"
#property description "CTsLogger -     ,"
#property description "         MQL5."
#property description ""
#property description "  CTsLogger -   "
#property description "        "
#property description "     ."
#property description ""
#property description " ,      "
#property description "   \"\"   ,"
#property description "     ."

#property script_show_inputs

//  
#include "CTsLogger.mqh"

//  
input string   InpLogFileName = "my_log.log"; //   
input bool     InpLogToTerminal = true;       //   

//    
CTsLogger *Logger = NULL;

//+------------------------------------------------------------------+
//| Script program start function                                    |
//+------------------------------------------------------------------+
void OnStart()
{
   //   
   Logger = new CTsLogger();
   
   //    
   if(Logger == NULL)
   {
      Print("  !");
      return;
   }
   
   //  
   Logger.Initialize(InpLogFileName, InpLogToTerminal);
   Logger.SetGlobalLogLevel(LOG_LEVEL_INFO);
   
   //  
   Logger.Info("LoggerScript", "   CTsLogger");
   Logger.Warning("LoggerScript", "   ");
   Logger.Error("LoggerScript", "     ");
   Logger.Debug("LoggerScript", "      ( INFO)");
   
   //   
   Logger.EnableDebugMode("Module");
   Logger.Debug("Module.Component", "    (  )");
   Logger.Debug("Module.OtherComponent", "    ");
   
   //        
   Logger.DisableDebugMode("Module");
   Logger.Debug("Module.Component", "    ");
   
   //   
   Logger.EnableDebugMode("Component1");
   Logger.EnableDebugMode("Component2");
   
   Logger.Debug("Component1", "   ");
   Logger.Debug("Component2", "   ");
   
   //  
   Logger.PauseDebugMode();
   Logger.Debug("Component1", "     (  )");
   
   //  
   Logger.ResumeDebugMode();
   Logger.Debug("Component1", "    ");
   
   //    
   Logger.SetGlobalLogLevel(LOG_LEVEL_DEBUG);
   Logger.Debug("LoggerScript", "     ");
   
   //    
   Logger.ResetDebugModules();
   
   // 
   Logger.Info("LoggerScript", " ");
   
   //   
   if(Logger != NULL)
   {
      delete Logger;
      Logger = NULL;
   }
}

